<?php
/**
 * ------------------------------------------------------------------------
 * JU ToC Plugin for Joomla 2.5, 3.x
 * ------------------------------------------------------------------------
 * Copyright (C) 2010-2013 JoomUltra. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: JoomUltra Co., Ltd
 * Websites: http://www.joomultra.com
 * ------------------------------------------------------------------------
 */

// No direct access.
defined('_JEXEC') or die();

if(!defined('DS')){
	define('DS', DIRECTORY_SEPARATOR);
}

/**
 * JUBlockIP Plugin
 *
 * @package		Joomla
 * @subpackage	System
 * @since 		2.5
 */

class plgSystemJUToC extends JPlugin
{
	/**
	 * Constructor
	 *
	 * @access      protected
	 * @param       object  $subject The object to observe
	 * @param       array   $config  An array that holds the plugin configuration
	 * @since       1.5
	 */
    function __construct(&$subject, $config)
    {
        parent::__construct($subject, $config);
    }
	
	/*
	* Check if jQurey is loaded or not
	*/
	protected function checkjQuery()
	{
		$body = JResponse::getBody();
		$regex= '#\<script.* src="([\/\\a-zA-Z0-9_:\.-]*)jquery([0-9\.-]|core|min|pack)*?.js".*\>\<\/script\>#m';
		preg_match($regex, $body, $matches);
		if (empty($matches)) return false;
		else return true;
	}
	
	/**
	* @since	1.6
	*/
    public function onAfterRender()
    {

	}
	
	public function onAfterRoute()
	{
		$runplugin = true;
		
		//Don't run plugin in backend
		$app = JFactory::getApplication();
		if ($app->isAdmin()) {
			$runplugin = false;
		}
		
		//Only run plugin in html mode
		$document = JFactory::getDocument();
		if ($document->getType() !== 'html' && $document->getType() !== 'feed') {
			$runplugin = false;
		}
		
		// enable plugin on the listed pages
		$enabledpage = false;
		$enablepaths = trim((string) $this->params->get('enablepaths'));
		if ($enablepaths) {
			$paths = array_map('trim', (array) explode("\n", $enablepaths));
			$current_uri_string = JURI::getInstance()->toString();
			
			foreach ($paths as $regex_pattern) {
				//preg_quote and remove ending slash of JURI::root()
				$root_path = preg_quote(preg_replace('#\/$#', '', JURI::root()), '/');
				$regex_pattern = "#".str_replace("[root]", $root_path, $regex_pattern)."#i";
				preg_match($regex_pattern, $current_uri_string, $matches);
				if (count($matches)) {
					$enabledpage = true;
					break;
				}
			}
		}
		
		// disable plugin in the listed pages, if the page is not in list of enabled pages
		$disablepaths = trim((string) $this->params->get('disablepaths'));
		$disabledpage = false;
		if (!$enabledpage && $disablepaths) {
			$paths = array_map('trim', (array) explode("\n", $disablepaths));
			$current_uri_string = JURI::getInstance()->toString();
			
			foreach ($paths as $regex_pattern) {
				//preg_quote and remove ending slash of JURI::root()
				$root_path = preg_quote(preg_replace('#\/$#', '', JURI::root()), '/');
				$regex_pattern = "#".str_replace("[root]", $root_path, $regex_pattern)."#i";
				preg_match($regex_pattern, $current_uri_string, $matches);
				if (count($matches)) {
					$disabledpage = true;
					break;
				}
			}
		}
		
		//Force run tab in enabled pages
		if(!$enabledpage && $disabledpage) {
			$runplugin = false;
		}
		
		//Don't runplugin, retun false;
		if(!$runplugin) {
			return false;
		}
		
		
		//Load jQuery
		if( $this->params->get('loadjquery', '2')==1 || ($this->params->get('loadjquery', '2')==2 && !self::checkjQuery()) ) {
			if($this->params->get('loadjqueryfrom', '1')==1) { $js_files[] = JURI::root(true)."/plugins/system/jutoc/assets/js/jquery.min.js"; }
			else if($this->params->get('loadjqueryfrom', '1')==2) { $js_files[] = "http://ajax.googleapis.com/ajax/libs/jquery/1.8.3/jquery.min.js"; }
		}
		$document->addScript(JURI::Root(true) . '/plugins/system/jutoc/assets/js/jquery-ui-1.9.1.custom.min.js');
		$document->addScript(JURI::Root(true) . '/plugins/system/jutoc/assets/js/jquery.tocify.min.js');
		$document->addScript(JURI::Root(true) . '/plugins/system/jutoc/assets/js/jquery.stickyPanel.min.js');
		$document->addScript(JURI::Root(true) . '/plugins/system/jutoc/assets/js/tinynav.min.js');
		$document->addStyleSheet(JURI::Root(true) . '/plugins/system/jutoc/assets/css/jquery.tocify.css');
		$document->addStyleSheet(JURI::Root(true) . '/plugins/system/jutoc/assets/css/style.css');
		
		$toc_param = array();
		
		$toc_param['context'] = '"' . $this->params->get('context', 'body') . '"';
		$toc_param['ignoreSelector'] = '"' . $this->params->get('ignoreSelector', '') . '"';
		$toc_param['selectors'] = '"' . $this->params->get('selectors', 'h1, h2, h3') . '"';
		$toc_param['showAndHide'] = $this->params->get('showAndHide', 'true');
		$toc_param['showEffect'] = '"' . $this->params->get('showEffect', 'slideDown') . '"';
		$toc_param['showEffectSpeed'] = $this->params->get('showEffectSpeed', 400);
		$toc_param['hideEffect'] = '"' . $this->params->get('hideEffect', 'slideUp') . '"';
		$toc_param['hideEffectSpeed'] = $this->params->get('hideEffectSpeed', 400);
		$toc_param['smoothScroll'] = $this->params->get('smoothScroll', 'true');
		$toc_param['smoothScrollSpeed'] = $this->params->get('smoothScrollSpeed', 400);
		$toc_param['scrollTo'] = $this->params->get('scrollTo', 0);
		$toc_param['showAndHideOnScroll'] = $this->params->get('showAndHideOnScroll', 'true');
		$toc_param['highlightOnScroll'] = $this->params->get('highlightOnScroll', 'true');
		$toc_param['highlightOffset'] = $this->params->get('highlightOffset', 40);
		$toc_param['theme'] = '"' . $this->params->get('theme', 'bootstrap') . '"';
		$toc_param['extendPage'] = $this->params->get('extendPage', 'false');
		$toc_param['extendPageOffset'] = $this->params->get('extendPageOffset', 100);
		$toc_param['history'] = $this->params->get('history', 'true');
		$toc_param['hashGenerator'] = '"' . $this->params->get('hashGenerator', 'compact') . '"';
		$toc_param['highlightDefault'] = $this->params->get('highlightDefault', 'true');
		$toc_param['onClickTocify'] = $this->params->get('onClickTocify', 'null');
		
		$toc_js_param = array();
		foreach($toc_param AS $key=>$value) {
			$toc_js_param[] = $key . ': ' . $value;
		}

		$toc_js_param_str = implode(', ', $toc_js_param);
		
		$javascript = '
		jQuery(document).ready(function($){
			$("' . $this->params->get('toclocation', '#jutoc') . '").' . $this->params->get('tocinsertion', 'html') . '("<div class=\'jutoc ' . $this->params->get('tocclass', '') . '\' style=\'max-height: ' . $this->params->get('tocmaxheight', '100%') . '\'></div>");
			$("' . $this->params->get('toclocation', '#jutoc') . ' .jutoc").tocify({' . $toc_js_param_str . '});';
		
		if($this->params->get('stickytoc', 1)) {
			$javascript .= '
				var JUToCStickyPanelOptions = {
					topPadding: ' . $this->params->get('topPadding', 0) . ',
					afterDetachCSSClass: "' . $this->params->get('afterDetachCSSClass', 'detached') . '",
					savePanelSpace: ' . $this->params->get('savePanelSpace', 'true') . ',
					onDetached: ' . $this->params->get('onDetached', 'null') . ',
					onReAttached: ' . $this->params->get('onReAttached', 'null') . ',
					parentSelector: "' . trim($this->params->get('parentSelector', '')) . '"
				};
				$("' . $this->params->get('toclocation', '#jutoc') . ' .jutoc").stickyPanel(JUToCStickyPanelOptions);
			';
		}
		
		if($this->params->get('responsive', 1)) {
			$css = '
			@media screen and (max-width: ' . $this->params->get('responsive_width', 600) . 'px) {
				.tinynav {
					display: block;
				}
				.jutoc {
					display: none;
				}
			}';
			
			$document->addStyleDeclaration($css);
			
			$tinyNav_param = array();
			$tinyNav_param['header'] = '"' . $this->params->get('navheader', '') . '"';
			$tinyNav_param['label'] = '"' . $this->params->get('navlabel', '') . '"';
			$tinyNav_param['navlocation'] = '"' . $this->params->get('navlocation', '') . '"';
			$tinyNav_param['navinsertion'] = '"' . $this->params->get('navinsertion', '') . '"';
			
			$tinyNav_js_param = array();
			foreach($tinyNav_param AS $key=>$value) {
				$tinyNav_js_param[] = $key . ': ' . $value;
			}
			
			$tinyNav_js_param_str = implode(', ', $tinyNav_js_param);
			
			$javascript .= '
				$("' . $this->params->get('toclocation', '#jutoc') . ' .jutoc").tinyNav({ ' . $tinyNav_js_param_str . ' });
			';
			
			if($this->params->get('stickynav', 1)) {
				$javascript .= '$(".tinynav").stickyPanel(JUToCStickyPanelOptions);';
			}
		}
		
		$javascript .= '});';
		
		$document->addScriptDeclaration($javascript);
	}
}
